REST Resource: urlMaps

Resource: UrlMap

Represents a URL Map resource.

Compute Engine has two URL Map resources:

A URL map resource is a component of certain types of cloud load balancers and Traffic Director:

  • urlMaps are used by global external Application Load Balancers, classic Application Load Balancers, and cross-region internal Application Load Balancers.
  • regionUrlMaps are used by internal Application Load Balancers, regional external Application Load Balancers and regional internal Application Load Balancers.

For a list of supported URL map features by the load balancer type, see the Load balancing features: Routing and traffic management table.

For a list of supported URL map features for Traffic Director, see the Traffic Director features: Routing and traffic management table.

This resource defines mappings from hostnames and URL paths to either a backend service or a backend bucket.

To use the global urlMaps resource, the backend service must have a loadBalancingScheme of either EXTERNAL, EXTERNAL_MANAGED, or INTERNAL_SELF_MANAGED. To use the regionUrlMaps resource, the backend service must have a loadBalancingScheme of INTERNAL_MANAGED. For more information, read URL Map Concepts.

JSON representation
{
  "kind": string,
  "id": string,
  "creationTimestamp": string,
  "name": string,
  "description": string,
  "selfLink": string,
  "hostRules": [
    {
      object (HostRule)
    }
  ],
  "pathMatchers": [
    {
      object (PathMatcher)
    }
  ],
  "tests": [
    {
      object (UrlMapTest)
    }
  ],
  "defaultService": string,
  "defaultRouteAction": {
    object (HttpRouteAction)
  },
  "defaultUrlRedirect": {
    object (HttpRedirectAction)
  },
  "headerAction": {
    object (HttpHeaderAction)
  },
  "defaultCustomErrorResponsePolicy": {
    object (CustomErrorResponsePolicy)
  },
  "fingerprint": string,
  "region": string
}
Fields
kind

string

Output only. Type of the resource. Always compute#urlMaps for url maps.

id

string (uint64 format)

Output only. The unique identifier for the resource. This identifier is defined by the server.

creationTimestamp

string

Output only. Creation timestamp in RFC3339 text format.

name

string

Name of the resource. Provided by the client when the resource is created. The name must be 1-63 characters long, and comply with RFC1035. Specifically, the name must be 1-63 characters long and match the regular expression [a-z]([-a-z0-9]*[a-z0-9])? which means the first character must be a lowercase letter, and all following characters must be a dash, lowercase letter, or digit, except the last character, which cannot be a dash.

description

string

An optional description of this resource. Provide this property when you create the resource.

hostRules[]

object (HostRule)

The list of host rules to use against the URL.

pathMatchers[]

object (PathMatcher)

The list of named PathMatchers to use against the URL.

tests[]

object (UrlMapTest)

The list of expected URL mapping tests. Request to update the UrlMap succeeds only if all test cases pass. You can specify a maximum of 100 tests per UrlMap.

Not supported when the URL map is bound to a target gRPC proxy that has validateForProxyless field set to true.

defaultService

string

The full or partial URL of the defaultService resource to which traffic is directed if none of the hostRules match. If defaultRouteAction is also specified, advanced routing actions, such as URL rewrites, take effect before sending the request to the backend.

Only one of defaultUrlRedirect, defaultService or defaultRouteAction.weightedBackendService can be set.

defaultService has no effect when the URL map is bound to a target gRPC proxy that has the validateForProxyless field set to true.

defaultRouteAction

object (HttpRouteAction)

defaultRouteAction takes effect when none of the hostRules match. The load balancer performs advanced routing actions, such as URL rewrites and header transformations, before forwarding the request to the selected backend.

Only one of defaultUrlRedirect, defaultService or defaultRouteAction.weightedBackendService can be set.

URL maps for classic Application Load Balancers only support the urlRewrite action within defaultRouteAction.

defaultRouteAction has no effect when the URL map is bound to a target gRPC proxy that has the validateForProxyless field set to true.

defaultUrlRedirect

object (HttpRedirectAction)

When none of the specified hostRules match, the request is redirected to a URL specified by defaultUrlRedirect.

Only one of defaultUrlRedirect, defaultService or defaultRouteAction.weightedBackendService can be set.

Not supported when the URL map is bound to a target gRPC proxy.

headerAction

object (HttpHeaderAction)

Specifies changes to request and response headers that need to take effect for the selected backendService.

The headerAction specified here take effect after headerAction specified under pathMatcher.

headerAction is not supported for load balancers that have their loadBalancingScheme set to EXTERNAL.

Not supported when the URL map is bound to a target gRPC proxy that has validateForProxyless field set to true.

defaultCustomErrorResponsePolicy

object (CustomErrorResponsePolicy)

defaultCustomErrorResponsePolicy specifies how the Load Balancer returns error responses when BackendServiceor BackendBucket responds with an error.

This policy takes effect at the load balancer level and applies only when no policy has been defined for the error code at lower levels like PathMatcher, RouteRule and PathRule within this UrlMap.

For example, consider a UrlMap with the following configuration:

  • defaultCustomErrorResponsePolicy containing policies for responding to 5xx and 4xx errors
  • A PathMatcher configured for *.example.com has defaultCustomErrorResponsePolicy for 4xx.

If a request for http://www.example.com/ encounters a 404, the policy in pathMatcher.defaultCustomErrorResponsePolicy will be enforced. When the request for http://www.example.com/ encounters a 502, the policy in UrlMap.defaultCustomErrorResponsePolicy will be enforced. When a request that does not match any host in *.example.com such as http://www.myotherexample.com/, encounters a 404, UrlMap.defaultCustomErrorResponsePolicy takes effect.

When used in conjunction with defaultRouteAction.retryPolicy, retries take precedence. Only once all retries are exhausted, the defaultCustomErrorResponsePolicy is applied. While attempting a retry, if load balancer is successful in reaching the service, the defaultCustomErrorResponsePolicy is ignored and the response from the service is returned to the client.

defaultCustomErrorResponsePolicy is supported only for global external Application Load Balancers.

fingerprint

string (bytes format)

Fingerprint of this resource. A hash of the contents stored in this object. This field is used in optimistic locking. This field is ignored when inserting a UrlMap. An up-to-date fingerprint must be provided in order to update the UrlMap, otherwise the request will fail with error 412 conditionNotMet.

To see the latest fingerprint, make a get() request to retrieve a UrlMap.

A base64-encoded string.

region

string

Output only. URL of the region where the regional URL map resides. This field is not applicable to global URL maps. You must specify this field as part of the HTTP request URL. It is not settable as a field in the request body.

Methods

aggregatedList

Retrieves the list of all UrlMap resources, regional and global, available to the specified project.

delete

Deletes the specified UrlMap resource.

get

Returns the specified UrlMap resource.

insert

Creates a UrlMap resource in the specified project using the data included in the request.

invalidateCache

Initiates a cache invalidation operation, invalidating the specified path, scoped to the specified UrlMap.

list

Retrieves the list of UrlMap resources available to the specified project.

patch

Patches the specified UrlMap resource with the data included in the request.

update

Updates the specified UrlMap resource with the data included in the request.

validate

Runs static validation for the UrlMap.

testIamPermissions

The method compute.v1.UrlMapsService.TestPermissions is not available in Cloud de Confiance by S3NS.